import io
from datetime import datetime


class Logger:
    def __init__(self, file_path):
        self.file_path = file_path

        with io.open(self.file_path, 'a', encoding='utf8') as file:
            file.write(self.get_headers())

    def log(self, location, message, data='', other=''):
        with io.open(self.file_path, 'a', encoding='utf8') as file:

            time_string = datetime.utcnow().strftime('%Y %m %d %H:%M:%S.%f')

            try:
                file.write(time_string + '|' + str(location).replace('|', '') + '|' + str(message).replace('|', '') +
                           '|' + str(data).replace('|', '') + '|' + str(other).replace('|', '') + '\n')
            except Exception as e:
                print('Failed to write to logger!')
                print(str(e))

    def get_path(self):
        return self.file_path

    @staticmethod
    def get_headers():
        headers = [
            'time',
            'location',
            'message',
            'data',
            'other'
        ]

        headers_string = ''
        for header in headers:
            headers_string += header.replace('|', '§') + '|'

        # Remove trailing '|'
        return headers_string[:-1] + '\n'
