from multiprocessing import Process, Queue
from time import time
from logger import Logger


class TweetQueuer:
    def __init__(self, log_path):
        self.logger = Logger(log_path)
        pass

    def start_queueing(self, receive_connection, end_time):
        queue = Queue()

        queue_process = Process(target=self.queue_tweets, args=(receive_connection, queue, end_time))
        queue_process.start()

        return [queue, queue_process]

    def queue_tweets(self, receive_connection, queue, end_time):
        while True:
            try:
                tweet = receive_connection.recv()

                queue.put(tweet)

                if time() >= end_time:
                    break
            except EOFError:
                break
            except Exception as e:
                self.logger.log('TweetQueuer/queue_tweets', 'Exception!', str(e))

        print('Tweet queuer exiting!')
        self.logger.log('TweetQueuer/queue_tweets', 'Tweet queuer exiting!')
        exit()
